Bug 530230 - Review Request: plpa - Portable Linux Processor Affinity
Summary: Review Request: plpa - Portable Linux Processor Affinity
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Susi Lehtola
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 531055
TreeView+ depends on / blocked
 
Reported: 2009-10-21 22:53 UTC by Steve Traylen
Modified: 2010-02-09 05:00 UTC (History)
4 users (show)

Fixed In Version: 1.3.2-3.fc11
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-02-09 03:58:42 UTC
Type: ---
susi.lehtola: fedora-review+
tibbs: fedora-cvs+


Attachments (Terms of Use)

Description Steve Traylen 2009-10-21 22:53:13 UTC
Spec URL: http://cern.ch/straylen/rpms/plpa/plpa.spec
SRPM URL: http://cern.ch/straylen/rpms/plpa/plpa-1.3.1-1.fc11.src.rpm
Description: 
PLPA is an attempt to solve the problem that there are multiple API's for
processor affinity within Linux. Specifically, the functions sched_setaffinity()
and sched_getaffinity() have numbers and types of parameters depending on your
Linux vendor and/or version of GLibc. This is quite problematic for applications
attempting to use processor affinity in Linux for compile-time, link-time,
and run-time reasons.

Comment 1 Steve Traylen 2009-10-21 23:09:15 UTC
Koji Build:
 http://koji.fedoraproject.org/koji/taskinfo?taskID=1761831$ 

rpmlint:
rpmlint SPECS/plpa.spec SRPMS/plpa-1.3.1-1.fc11.src.rpm RPMS/x86_64/plpa-*
plpa-devel.x86_64: W: no-documentation
5 packages and 1 specfiles checked; 0 errors, 1 warnings.

Comment 2 Susi Lehtola 2009-10-23 10:04:56 UTC
This looks potentially useful. Taking review.

PS. Change
 %{_libdir}/libplpa.so.0
 %{_libdir}/libplpa.so.0.0.0
to
 %{_libdir}/libplpa.so.*

Comment 4 Susi Lehtola 2009-10-23 14:41:53 UTC
rpmlint output:
plpa-devel.x86_64: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 1 warnings.


MUST: The package does not yet exist in Fedora. The Review Request is not a duplicate. OK
MUST: The spec file for the package is legible and macros are used consistently. OK
MUST: The package must be named according to the Package Naming Guidelines. OK
MUST: The spec file name must match the base package %{name}. OK
MUST: The package must be licensed with a Fedora approved license and meet the  Licensing Guidelines. OK

MUST: The License field in the package spec file must match the actual license. ??
- The file src/libplpa/plpa_map.c has an odd license header [see bottom].
- Otherwise the files don't have license headers, attached LICENSE is a 3-clause BSD license.

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. OK
MUST: The package MUST successfully compile and build into binary rpms. OK
MUST: The spec file MUST handle locales properly. N/A
MUST: Optflags are used and time stamps preserved. OK
MUST: Packages containing shared library files must call ldconfig. OK
MUST: A package must own all directories that it creates or require the package that owns the directory. OK
MUST: Files only listed once in %files listings. OK
MUST: Debuginfo package is complete. OK
MUST: Permissions on files must be set properly. OK
MUST: Clean section exists. OK
MUST: Large documentation files must go in a -doc subpackage. N/A

MUST: All relevant items are included in %doc. Items in %doc do not affect runtime of application. OK
- The main package requires the libs package anyway, so place all of the docs in the lib package. (The lib package can be installed without the main package, so the docs should be there.)

MUST: Header files must be in a -devel package. OK
MUST: Static libraries must be in a -static package. N/A
MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig'. N/A
MUST: If a package contains library files with a suffix then library files ending in .so must go in a -devel package. OK
MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency. OK
MUST: Packages does not contain any .la libtool archives. OK
MUST: Desktop files are installed properly. N/A
MUST: No file conflicts with other packages and no general names. OK
MUST: Buildroot cleaned before install. OK
SHOULD: %{?dist} tag is used in release. OK
SHOULD: If the package does not include license text(s) as separate files from upstream, the packager should query upstream to include it. OK
SHOULD: The package builds in mock. OK


License header from src/libplpa/plpa_map.c:

License Agreement

 Copyright (c) 2006, 2007 Advanced Micro Devices, Inc.
 All rights reserved.

 Redistribution and use in any form of this material and any product 
 thereof including software in source or binary forms, along with any 
 related documentation, with or without modification ("this material"), 
 is permitted provided that the following conditions are met:

 + Redistributions of source code of any software must retain the above
 copyright notice and all terms of this license as part of the code.

 + Redistributions in binary form of any software must reproduce the
 above copyright notice and all terms of this license in any related 
 documentation and/or other materials.

 + Neither the names nor trademarks of Advanced Micro Devices, Inc. or
 any copyright holders or contributors may be used to endorse or 
 promote products derived from this material without specific prior 
 written permission.

 + Notice about U.S. Government restricted rights: This material is
 provided with "RESTRICTED RIGHTS." Use, duplication or disclosure by 
 the U.S. Government is subject to the full extent of restrictions set 
 forth in FAR52.227 and DFARS252.227 et seq., or any successor or 
 applicable regulations. Use of this material by the U.S. Government 
 constitutes acknowledgment of the proprietary rights of Advanced Micro 
 Devices, Inc.
 and any copyright holders and contributors.

 + In no event shall anyone redistributing or accessing or using this
 material commence or participate in any arbitration or legal action 
 relating to this material against Advanced Micro Devices, Inc. or any 
 copyright holders or contributors. The foregoing shall survive any 
 expiration or termination of this license or any agreement or access 
 or use related to this material.

 + ANY BREACH OF ANY TERM OF THIS LICENSE SHALL RESULT IN THE IMMEDIATE
 REVOCATION OF ALL RIGHTS TO REDISTRIBUTE, ACCESS OR USE THIS MATERIAL.

 THIS MATERIAL IS PROVIDED BY ADVANCED MICRO DEVICES, INC. AND ANY 
 COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" IN ITS CURRENT CONDITION 
 AND WITHOUT ANY REPRESENTATIONS, GUARANTEE, OR WARRANTY OF ANY KIND OR 
 IN ANY WAY RELATED TO SUPPORT, INDEMNITY, ERROR FREE OR UNINTERRUPTED 
 OPERATION, OR THAT IT IS FREE FROM DEFECTS OR VIRUSES.  ALL 
 OBLIGATIONS ARE HEREBY DISCLAIMED - WHETHER EXPRESS, IMPLIED, OR 
 STATUTORY - INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OF 
 TITLE, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, ACCURACY, 
 COMPLETENESS, OPERABILITY, QUALITY OF SERVICE, OR NON-INFRINGEMENT. IN 
 NO EVENT SHALL ADVANCED MICRO DEVICES, INC. OR ANY COPYRIGHT HOLDERS 
 OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 SPECIAL, PUNITIVE, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
 NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 USE, REVENUE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 CAUSED OR BASED ON ANY THEORY OF LIABILITY ARISING IN ANY WAY RELATED 
 TO THIS MATERIAL, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 THE ENTIRE AND AGGREGATE LIABILITY OF ADVANCED MICRO DEVICES, INC. AND 
 ANY COPYRIGHT HOLDERS AND CONTRIBUTORS SHALL NOT EXCEED TEN DOLLARS 
 (US $10.00). ANYONE REDISTRIBUTING OR ACCESSING OR USING THIS MATERIAL 
 ACCEPTS THIS ALLOCATION OF RISK AND AGREES TO RELEASE ADVANCED MICRO 
 DEVICES, INC. AND ANY COPYRIGHT HOLDERS AND CONTRIBUTORS FROM ANY AND 
 ALL LIABILITIES, OBLIGATIONS, CLAIMS, OR DEMANDS IN EXCESS OF TEN 
 DOLLARS (US $10.00). THE FOREGOING ARE ESSENTIAL TERMS OF THIS LICENSE 
 AND, IF ANY OF THESE TERMS ARE CONSTRUED AS UNENFORCEABLE, FAIL IN 
 ESSENTIAL PURPOSE, OR BECOME VOID OR DETRIMENTAL TO ADVANCED MICRO 
 DEVICES, INC. OR ANY COPYRIGHT HOLDERS OR CONTRIBUTORS FOR ANY REASON, 
 THEN ALL RIGHTS TO REDISTRIBUTE, ACCESS OR USE THIS MATERIAL SHALL 
 TERMINATE IMMEDIATELY. MOREOVER, THE FOREGOING SHALL SURVIVE ANY 
 EXPIRATION OR TERMINATION OF THIS LICENSE OR ANY AGREEMENT OR ACCESS 
 OR USE RELATED TO THIS MATERIAL.

 NOTICE IS HEREBY PROVIDED, AND BY REDISTRIBUTING OR ACCESSING OR USING 
 THIS MATERIAL SUCH NOTICE IS ACKNOWLEDGED, THAT THIS MATERIAL MAY BE 
 SUBJECT TO RESTRICTIONS UNDER THE LAWS AND REGULATIONS OF THE UNITED 
 STATES OR OTHER COUNTRIES, WHICH INCLUDE BUT ARE NOT LIMITED TO, U.S.
 EXPORT CONTROL LAWS SUCH AS THE EXPORT ADMINISTRATION REGULATIONS AND 
 NATIONAL SECURITY CONTROLS AS DEFINED THEREUNDER, AS WELL AS STATE 
 DEPARTMENT CONTROLS UNDER THE U.S. MUNITIONS LIST. THIS MATERIAL MAY 
 NOT BE USED, RELEASED, TRANSFERRED, IMPORTED, EXPORTED AND/OR RE- 
 EXPORTED IN ANY MANNER PROHIBITED UNDER ANY APPLICABLE LAWS, INCLUDING 
 U.S. EXPORT CONTROL LAWS REGARDING SPECIFICALLY DESIGNATED PERSONS, 
 COUNTRIES AND NATIONALS OF COUNTRIES SUBJECT TO NATIONAL SECURITY 
 CONTROLS.
 MOREOVER,
 THE FOREGOING SHALL SURVIVE ANY EXPIRATION OR TERMINATION OF ANY 
 LICENSE OR AGREEMENT OR ACCESS OR USE RELATED TO THIS MATERIAL.

 This license forms the entire agreement regarding the subject matter 
 hereof and supersedes all proposals and prior discussions and writings 
 between the parties with respect thereto. This license does not affect 
 any ownership, rights, title, or interest in, or relating to, this 
 material. No terms of this license can be modified or waived, and no 
 breach of this license can be excused, unless done so in a writing 
 signed by all affected parties. Each term of this license is 
 separately enforceable. If any term of this license is determined to 
 be or becomes unenforceable or illegal, such term shall be reformed to 
 the minimum extent necessary in order for this license to remain in 
 effect in accordance with its terms as modified by such reformation.
 This license shall be governed by and construed in accordance with the 
 laws of the State of Texas without regard to rules on conflicts of law 
 of any state or jurisdiction or the United Nations Convention on the 
 International Sale of Goods. All disputes arising out of this license 
 shall be subject to the jurisdiction of the federal and state courts 
 in Austin, Texas, and all defenses are hereby waived concerning 
 personal jurisdiction and venue of these courts.

Comment 5 Steve Traylen 2009-10-23 18:19:01 UTC
Looking around to understand about this license I noticed
the released htop package contains a 
private and compiled in copy of plpa.
http://kojipkgs.fedoraproject.org/packages/htop/0.8.3/2.fc12/data/logs/i686/build.log

Regardless of if this accepted or not I'll submit a bug on htop following
this. The bug for htop rather depends upon the resolution of this license
item first though either way.
htop is marked as GPL+ so something is definitely wrong.
Steve

Comment 6 Susi Lehtola 2009-10-23 18:25:08 UTC
Good catch.

Can you contact upstream to clarify the license issue? (Unless someone from legal OKs the license in comment #4.)

Comment 7 Steve Traylen 2009-10-23 18:45:47 UTC
I'll wait on legal first. To me the license on plpa_map.c
looks very similar to some of the examples on
https://fedoraproject.org/wiki/Licensing/BSD
but needs signing of. With regards to upstream the license is clear
in the files so at the moment it's not obvious they could offer extra
information at this point.

Steve

Comment 8 Steve Traylen 2009-10-26 17:18:52 UTC
Have submitted a htop bug as well now bug #531055 to make maintainer
aware.
Steve

Comment 9 Tom "spot" Callaway 2009-11-30 21:49:18 UTC
FYI, I'm waiting on Red Hat Legal here.

Comment 10 Tom "spot" Callaway 2009-11-30 22:20:28 UTC
Red Hat Legal agrees with me that this license is non-free, because of the "legal action" clause. This probably means that htop needs to come out too, unless the license issue can be clarified (or that code removed from plpa).

Comment 11 Tom "spot" Callaway 2009-11-30 22:21:38 UTC
In addition, if AMD was to drop that clause, the rest of the license would still be GPL incompatible, so it would not be appropriate for htop.

Comment 12 Tom "spot" Callaway 2010-01-08 20:35:14 UTC
Upstream has resolved the main licensing issue with AMD, which means that the license on plpa_map.c in PLPA 1.3.2 is now Free, making PLPA acceptable for Fedora.

Unfortunately, AMD was unable to drop the export clauses from the plpa_map.c license, so plpa_map.c is Free but GPL Incompatible.

I'm working with Red Hat Legal to propose an exception clause to cover this case for the GPL, and will propose it to the htop upstream. If they add the additional clause, we should be able to resolve 531055 without removing htop.

Steve, if you're still interested in maintaining this package, please feel free to reopen. You'll need to make a new package using 1.3.2, and change the License tag to read:

License: BSD and AMDPLPA

Comment 13 Steve Traylen 2010-01-12 23:03:20 UTC
Tom, thanks awfully for following this up. Pleased and impressed 
it is resolved.

I would be interested in the kind of clause that is needed for 
htop. In particular the whole motivation for plpa was to then add
on to the GPLv2 licensed SLURM. 
https://computing.llnl.gov/linux/slurm/slurm.html

Jussi, here are new amended packages now not blocked by a legal situation.
Version 1.3.2 and licensed as BSD and AMDPLPA.

http://cern.ch/straylen/rpms/plpa/plpa-1.3.2-1.fc12.src.rpm
http://cern.ch/straylen/rpms/plpa/plpa.spec

Comment 14 Susi Lehtola 2010-01-13 09:51:56 UTC
The only issue holding the review was the license, which has been resolved according to comment #12; removing FE-LEGAL.

Please move all %doc to -libs before cvs import. This package has been

APPROVED

Comment 16 Steve Traylen 2010-01-14 22:48:21 UTC
New Package CVS Request
=======================
Package Name: plpa
Short Description: Portable Linux Processor Affinity
Owners: stevetraylen
Branches: F-11 F-12 EL-5 EL-4
InitialCC:

Comment 17 Jason Tibbitts 2010-01-14 22:57:29 UTC
CVS done (by process-cvs-requests.py).

Comment 18 Fedora Update System 2010-01-16 19:22:06 UTC
plpa-1.3.2-3.fc12 has been submitted as an update for Fedora 12.
http://admin.fedoraproject.org/updates/plpa-1.3.2-3.fc12

Comment 19 Fedora Update System 2010-01-16 19:23:18 UTC
plpa-1.3.2-3.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/plpa-1.3.2-3.fc11

Comment 20 Fedora Update System 2010-01-16 22:55:37 UTC
plpa-1.3.2-4.el4 has been submitted as an update for Fedora EPEL 4.
http://admin.fedoraproject.org/updates/plpa-1.3.2-4.el4

Comment 21 Fedora Update System 2010-01-16 22:56:10 UTC
plpa-1.3.2-4.el5 has been submitted as an update for Fedora EPEL 5.
http://admin.fedoraproject.org/updates/plpa-1.3.2-4.el5

Comment 22 Fedora Update System 2010-01-17 02:53:19 UTC
plpa-1.3.2-3.fc11 has been pushed to the Fedora 11 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update plpa'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F11/FEDORA-2010-0675

Comment 23 Fedora Update System 2010-01-17 02:53:42 UTC
plpa-1.3.2-3.fc12 has been pushed to the Fedora 12 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update plpa'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F12/FEDORA-2010-0680

Comment 24 Fedora Update System 2010-01-18 23:21:07 UTC
plpa-1.3.2-4.el4 has been pushed to the Fedora EPEL 4 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update plpa'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/EL-4/FEDORA-EPEL-2010-0066

Comment 25 Fedora Update System 2010-01-18 23:23:59 UTC
plpa-1.3.2-4.el5 has been pushed to the Fedora EPEL 5 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update plpa'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/EL-5/FEDORA-EPEL-2010-0085

Comment 26 Fedora Update System 2010-02-09 03:58:35 UTC
plpa-1.3.2-4.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 27 Fedora Update System 2010-02-09 03:59:24 UTC
plpa-1.3.2-4.el4 has been pushed to the Fedora EPEL 4 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 28 Fedora Update System 2010-02-09 04:57:50 UTC
plpa-1.3.2-3.fc12 has been pushed to the Fedora 12 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 29 Fedora Update System 2010-02-09 05:00:13 UTC
plpa-1.3.2-3.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.